#ifndef AUTO_H
#define AUTO_H

#include "program.h"
#include "var.h"
#include "token.h"

struct Auto
{
  long int stackPointer;
  long int stackCapacity;
  long int framePointer;
  long int frameSize;
  struct Pc onerror;
  union AutoSlot *slot;

  int symCapacity;
  int symSize;
  struct AutoSym *sym;
};

union AutoSlot
{
  struct
  {
    long int framePointer;
    long int frameSize;
    struct Pc pc;
  } ret;
  struct Var var;
};

struct AutoSym
{
  const char *identifier;
  enum ValueType type;
  struct Symbol sym;
};

#endif
