#ifndef FILE_H
#define FILE_H

#include "str.h"

struct FileStream
{
  int dev,tty;

  int infd;
  char inBuf[128];
  size_t inSize,inCapacity;

  int outfd;
  int outPos;
  int outLineWidth;
  int outColWidth;
  char outBuf[128];
  size_t outSize,outCapacity;

  int randomfd;
  int recLength;
  int recPos;
  char *recBuf;
  struct StringField field;
};

extern const char *FS_errmsg;

extern int FS_opendev(int dev, int infd, int outfd);
extern int FS_openin(const char *name);
extern int FS_openinChn(int chn, const char *name);
extern int FS_openout(const char *name, int tmp);
extern int FS_openoutChn(int chn, const char *name);
extern int FS_openrandomChn(int chn, const char *name, int recLength);
extern int FS_flush(int dev);
extern int FS_close(int dev);
extern void FS_shellmode(int chn);
extern void FS_fsmode(int chn);
extern int FS_put(int chn);
extern int FS_putChar(int dev, char ch);
extern int FS_putChars(int dev, const char *chars);
extern int FS_putString(int dev, const struct String *s);
extern int FS_nextcol(int dev);
extern int FS_tab(int dev, int position);
extern int FS_cls(int chn);
extern int FS_locate(int chn, int line, int column);
extern int FS_get(int chn);
extern int FS_getChar(int dev);
extern int FS_eof(int chn);
extern long int FS_lof(int chn);
extern int FS_width(int dev, int width);
extern long int FS_recLength(int chn);
extern void FS_field(int chn, struct String *s, long int position, long int length);
extern int FS_appendToString(int dev, struct String *s, char stop, int onl);
extern int FS_inkeyChar(int dev, int ms);
extern int FS_seek(long int chn, long int record);
extern void FS_closefiles(void);

#endif
